/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

#include <stdio.h>
#include <new>

struct B {
       int i;
       B(int i_) : i(i_) {}
       virtual void vf() { printf("B::vf %d\n", i); }
};

struct D : B {
       D(int i) : B(i) {}
       virtual void vf() { printf("D::vf %d\n", i); }

       void f(const B& b2)
       {
        B* ptr=this;
        ptr->~B();
        new(ptr) B(b2);
       }
};

int main()
{
 D d(1);
 B* ptr=&d;
 ptr->vf();  //  D::vf 1

 d.f(B(2));
 ptr->vf();  //  B::vf 2
}
