/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

#include "b.hpp"
#include "../a.hpp"  //    -

//   --    B
struct B::Internal {
       A a;

       Internal(int i) : a(i) {}
       Internal(const Internal& in) : a(in.a) {}
       void operator=(const Internal& in) { a=in.a; }
       ~Internal() { a.preDestr(); }
       void privF() { a.f(); }  //   
};

B::B(int i) : impl(new Internal(i))
{
 //       ,   
 //   Internal -  
}

B::B(const B& b) : impl(new Internal(*b.impl))
{
 //       ,   
 //   Internal -  
}

B& B::operator=(const B& b)
{
 *impl=*b.impl;
 return *this;
}

B::~B()
{
 delete impl;
}

void B::f()
{
 impl->privF();
}

