/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

#include "b.hpp"
#include "../a.hpp"  //    -

//  BImpl,   B (  )
class BImpl : public B {
 private:
      virtual B* clone() const { return new BImpl(*this); }
      virtual void assign(const B& b);
      virtual ~BImpl() { a.preDestr(); }
      virtual void f() { privF(); }

      A a;

      BImpl(int i) : a(i) {}
      BImpl(const BImpl& b) : a(b.a) {}
      void privF() { a.f(); }
      BImpl& operator=(const BImpl& b);  //  

      friend B* createB(int i);  //     
};

//  ,  __   B
//          
//     ,     
// assign()  
void BImpl::assign(const B& b)
{
 // ,      BImpl,    
 //  
 const BImpl& bi(dynamic_cast<const BImpl&>(b));
 a=bi.a;
}

B* createB(int i)
{
 return new BImpl(i);
}

