/*
 * Copyright (C) Sergey P. Derevyago, 2003-2004.
 *
 * Permission to copy, use, modify, sell and distribute this software is granted
 * provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied warranty, and
 * with no claim as to its suitability for any purpose.
 *
 */

#include <stdlib.h>
#include <time.h>
#include <stdio.h>

const int nelem=1000;  //    

class Vec1 {
      int m[nelem];
 public:
      int& operator[](int i) { return m[i]; }
};

class Vec2 {
      int* m;
 public:
      Vec2() : m(new int[nelem]) {}
      ~Vec2() { delete [] m; }
      int& operator[](int i) { return m[i]; }
};

template<class T>
void f(long niters)
{
 T v;
 clock_t c1=clock();

 for (long i=0; i<niters; i++)
     for (long j=1; j<1000; j++)
         for (long k=1; k<nelem; k++) v[k-1]=v[k];

 clock_t c2=clock();
 printf("push: %ld thnds passes per %.1f sec\n", niters, double(c2-c1)/CLK_TCK);
}

int main(int argc, char** argv)
{
 long niters=500;
 if (argc>1) niters=atol(argv[1]);

 puts("Vec1");
 f<Vec1>(niters);

 puts("Vec2");
 f<Vec2>(niters);
}
